void drawStillFrame() {
  for (int i = 0; i< 7; i++) {
    // bar
    PVector p1 = PVector.lerp(Points[i], Points[(i+1)%7], 0.1);
    PVector p2 = PVector.lerp(Points[i], Points[(i+1)%7], 0.9);
    //println(p1);
    beginShape(LINES);
    strokeWeight(3);
    stroke(colors[i], 20);
    vertex(p1.x, p1.y, p1.z);
    strokeWeight(3);
    if (i==whichSinToSee-1 || whichSinToSee ==0) {
      stroke(colors[i], 200);
    } else {
      stroke(colors[i], 20);
    }
    vertex(p2.x, p2.y, p2.z);
    endShape();

    // count label
    pushMatrix();
    translate(p2.x, p2.y, p2.z);
    rotateZ((2*i+1)*PI/7+PI);
    textAlign(RIGHT, TOP);
    textFont(fonts[0], 20);
    text(str(MaxCheckoutCount[i]), -10, 0, 0);
    popMatrix();

    pushMatrix();
    translate(p1.x, p1.y, p1.z);
    rotateZ((2*i+1)*PI/7+PI);
    textAlign(RIGHT, BOTTOM);
    text(str(MinCheckoutCount[i]), -5, 0, 0);
    popMatrix();
  }

  beginShape(LINES);
  for (int i = 0; i< 7; i++) {
   PVector p1 = PVector.lerp(Points[i], Points[(i+1)%7], 0.1);
   PVector p2 = PVector.lerp(Points[i], Points[(i+1)%7], 0.9);
   //println(p1);
   strokeWeight(3);
   if (i==whichSinToSee-1 || whichSinToSee ==0) {
     stroke(colors[i], 255);
   } else {
     stroke(colors[i], 20);
   }
   vertex(p1.x*2, p1.y*2, p1.z);
   vertex(p2.x*2, p2.y*2, p2.z);
  }
  endShape();

  for (int i = 0; i< 7; i++) {
    PVector p3 = PVector.lerp(Points[i], Points[(i+1)%7], 0.5);
    pushMatrix();
    translate(p3.x*1.5, p3.y*1.5, p3.z);
    rotate((i+0.5)*2*PI/7+PI/2);
    fill(colors[9], 200);
    textAlign(CENTER, BOTTOM);
    textFont(fonts[0], 48);
    text(sevenDeadlySins[i], 0, 0, 0);
    popMatrix();
  }

  drawYearLabel();
}


void drawYearLabel() {
  for (int year = 1989; year<2015; year++) {
    float z = (year - interpolatorYear) * panelDistance;
    pushMatrix();
    translate(0, 0, z+2);
    rotateY(-PI/2);
    fill(colors[9], 200);
    textFont(fonts[0], 10);
    textAlign(LEFT);
    if (year== 1990)
      text("<"+str(year+1), 0, 0, 0);
    else if (year == 1989) {
      textFont(fonts[0], 20);
      //textWidth("Publish Year");
      text("Publish Year", -textWidth("Publish Year"), 0, 0);
      textFont(fonts[0], 10);
    } else
      text(str(year), 0, 0, 0);
    popMatrix();
  }
}