void controllerSetup() {
  cp5 = new ControlP5(this);

  ControlFont labelFont = new ControlFont(fonts[0], 16);
  ControlFont valueFont = new ControlFont(fonts[1], 12);

  l = cp5.addListBox("myList")
    .setPosition(width/16, height/2 + 150)
    .setSize(width/4-width/16, 3*height/8 - 150)
    .setItemHeight(15)
    .setBarHeight(15)
    .setColorBackground(0xFFFFFFFF)
    .setColorActive(color(0))
    .setColorForeground(0xFFEB6002)
    ;
  l.getCaptionLabel().toUpperCase(true);
  l.getCaptionLabel().set("Item Title");
  l.getCaptionLabel().setColor(colors[9]);
  l.getCaptionLabel().setFont(labelFont);
  l.getCaptionLabel().getStyle().marginTop= 5;
  l.getCaptionLabel().getStyle().marginLeft= -5;
  l.getValueLabel().setColor(colors[9]);
  l.getValueLabel().setFont(valueFont);
  l.getValueLabel().getStyle().marginTop= 5;
  l.getValueLabel().getStyle().marginLeft= -5;
  for (int i=0; i<rowNums; i++) {
    String title = nf(i, 3)+" "+ dataTable.getRow(i).getString(0);
    int maxLength = int((width/4-width/16)/7);
    if (title.length()>maxLength) title= title.substring(0, maxLength);
    l.addItem(title, i);
    CColor c = new CColor();
    //c.setBackground(0x14141400);
    c.setBackground(0xFFFFFFFF);
    //println(c);
    l.getItem(title).put("color", c);
    println(l.getItem(title));
  }
  cp5.setAutoDraw(false);
}

void controlEvent(ControlEvent theEvent) {

  //println(theEvent.getController().getId());
}




void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();

  float horizonalLocation = width/16;
  float verticalLocation = height/2;
  float dist = 25;

  fill(0, 15);
  noStroke();
  //rect(width/32, height/16, width/4, height/8);
  rect(width/32, height/2-height/16, width/4, height/2);

  boolean isMouseInX = (mouseX > width/32) && (mouseX<(width/4+width/32));
  boolean isMouseInY = (mouseY > (height/2-height/16)) && (mouseY <(height-height/16));
  boolean isMouseIn = isMouseInX && isMouseInY;

  if (isMouseIn)cam.setActive(false);
  else cam.setActive(true);

  fill(colors[9], 200);
  textFont(fonts[1], 16);
  textAlign(LEFT, BOTTOM);
  text("The 7 prevalently checked out items of", horizonalLocation, height/8-20);
  textFont(fonts[0], 48);
  textAlign(LEFT, TOP);
  text("7 DEADLY SINS", horizonalLocation, height/8);

  textAlign(LEFT, TOP);
  if (presentYear == 1990) {
    fill(colors[9], 200);
    textFont(fonts[0], 24);
    text("BEFORE ", horizonalLocation, verticalLocation-40);
    textFont(fonts[0], 48);
    text(str(presentYear+1), horizonalLocation, verticalLocation);
  } else if (presentYear > 1990 && presentYear < 2015) {
    fill(colors[9], 200);
    textFont(fonts[0], 48);
    text(str(presentYear), horizonalLocation, verticalLocation);
  } else {
    fill(50, 200);
    textFont(fonts[0], 48);
    text(str(presentYear), horizonalLocation, verticalLocation);
  }


  textFont(fonts[0], 24);
  if (showBook) fill(colors[9], 200);
  else fill(100, 200);
  text("Book", horizonalLocation, verticalLocation + 50);
  if (showVideo) fill(colors[9], 200);
  else fill(100, 200);
  text("Video", horizonalLocation, verticalLocation + dist + 50);
  if (showAudio) fill(colors[9], 200);
  else fill(100, 200);
  text("Audio", horizonalLocation, verticalLocation + dist*2 + 50);

  pushMatrix();
  translate(width*7/8,height*13/16);
  beginShape(LINES);
  for (int i = 0; i< 7; i++) {
    PVector p1 = PVector.lerp(Points[i], Points[(i+1)%7], 0.1);
    PVector p2 = PVector.lerp(Points[i], Points[(i+1)%7], 0.9);
    //println(p1);
    strokeWeight(3);
    if (i==whichSinToSee-1 || whichSinToSee ==0) {
      stroke(colors[i], 255);
    } else {
      stroke(colors[i], 20);
    }
    vertex(p1.x/5, p1.y/5, 0);
    vertex(p2.x/5, p2.y/5, 0);
  }
  endShape();
  
  for (int i = 0; i< 7; i++) {
   PVector p3 = PVector.lerp(Points[i], Points[(i+1)%7], 0.5);
   pushMatrix();
   translate(p3.x/5*1.1, p3.y/5*1.1);
   rotate((i+0.5)*2*PI/7+PI/2);
   fill(colors[9], 200);
   textAlign(CENTER, BOTTOM);
   textFont(fonts[0], 12);
   text(sevenDeadlySins[i], 0, 0);
   popMatrix();
  }
  popMatrix();

  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}